
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class DocumentsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const documents = await db.documents.create(
            {
                id: data.id || undefined,
        
        title: data.title
        ||
        null
            ,
            
        content_markdown: data.content_markdown
        ||
        null
            ,
            
        current_version_number: data.current_version_number
        ||
        null
            ,
            
        last_edited_at: data.last_edited_at
        ||
        null
            ,
            
        is_archived: data.is_archived
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await documents.setTeam( data.team || null, {
            transaction,
        });
        
        await documents.setAuthor( data.author || null, {
            transaction,
        });
        
        await documents.setFolder( data.folder || null, {
            transaction,
        });
        
        await documents.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return documents;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const documentsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                title: item.title
            ||
            null
            ,
            
                content_markdown: item.content_markdown
            ||
            null
            ,
            
                current_version_number: item.current_version_number
            ||
            null
            ,
            
                last_edited_at: item.last_edited_at
            ||
            null
            ,
            
                is_archived: item.is_archived
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const documents = await db.documents.bulkCreate(documentsData, { transaction });

        // For each item created, replace relation files
        

        return documents;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const documents = await db.documents.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.content_markdown !== undefined) updatePayload.content_markdown = data.content_markdown;
        
        
        if (data.current_version_number !== undefined) updatePayload.current_version_number = data.current_version_number;
        
        
        if (data.last_edited_at !== undefined) updatePayload.last_edited_at = data.last_edited_at;
        
        
        if (data.is_archived !== undefined) updatePayload.is_archived = data.is_archived;
        
        
        updatePayload.updatedById = currentUser.id;

        await documents.update(updatePayload, {transaction});

        
        
        if (data.team !== undefined) {
            await documents.setTeam(
              
              data.team,
              
              { transaction }
            );
        }
        
        if (data.author !== undefined) {
            await documents.setAuthor(
              
              data.author,
              
              { transaction }
            );
        }
        
        if (data.folder !== undefined) {
            await documents.setFolder(
              
              data.folder,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await documents.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return documents;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const documents = await db.documents.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of documents) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of documents) {
                await record.destroy({transaction});
            }
        });


        return documents;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const documents = await db.documents.findByPk(id, options);

        await documents.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await documents.destroy({
            transaction
        });

        return documents;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const documents = await db.documents.findOne(
            { where },
            { transaction },
        );

        if (!documents) {
            return documents;
        }

        const output = documents.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        output.document_versions_document = await documents.getDocument_versions_document({
            transaction
        });
        
        
        output.story_document_links_document = await documents.getStory_document_links_document({
            transaction
        });
        
        
        output.collaboration_sessions_document = await documents.getCollaboration_sessions_document({
            transaction
        });
        
        
        output.comment_threads_document = await documents.getComment_threads_document({
            transaction
        });
        
        
        
        
        
        
        output.approvals_document = await documents.getApprovals_document({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        output.team = await documents.getTeam({
            transaction
        });
        
        
        output.author = await documents.getAuthor({
            transaction
        });
        
        
        output.folder = await documents.getFolder({
            transaction
        });
        
        
        output.organizations = await documents.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.teams,
        as: 'team',
        
        where: filter.team ? {
          [Op.or]: [
            { id: { [Op.in]: filter.team.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.team.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'author',
        
        where: filter.author ? {
          [Op.or]: [
            { id: { [Op.in]: filter.author.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.author.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.document_folders,
        as: 'folder',
        
        where: filter.folder ? {
          [Op.or]: [
            { id: { [Op.in]: filter.folder.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.folder.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'documents',
                        'title',
                        filter.title,
                    ),
                };
            }
            
            if (filter.content_markdown) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'documents',
                        'content_markdown',
                        filter.content_markdown,
                    ),
                };
            }
            

            
            

            
            if (filter.current_version_numberRange) {
                const [start, end] = filter.current_version_numberRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    current_version_number: {
                    ...where.current_version_number,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    current_version_number: {
                    ...where.current_version_number,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.last_edited_atRange) {
                const [start, end] = filter.last_edited_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    last_edited_at: {
                    ...where.last_edited_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    last_edited_at: {
                    ...where.last_edited_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_archived) {
                where = {
                    ...where,
                is_archived: filter.is_archived,
            };
            }
            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.documents.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'documents',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.documents.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

